﻿/*
 * Copyright 2009, Payton Byrd
 * Licensed Under the Microsoft Public License (MS-PL)
 */

using PaytonByrd.Extensions;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace PaytonByrd.Extensions.UnitTests
{
    
    
    /// <summary>
    ///This is a test class for ReflectionExtensionsTest and is intended
    ///to contain all ReflectionExtensionsTest Unit Tests
    ///</summary>
    [TestClass()]
    public class ReflectionExtensionsTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for CreateInstance
        ///</summary>
        [TestMethod()]
        public void CreateInstanceTestNonDefaultConstructor()
        {
            Type type = typeof(GenericParameterHelper); 
            object[] parameters = new object[] { 1 }; 
            GenericParameterHelper expected = new GenericParameterHelper(1); 
            GenericParameterHelper actual;
            actual = type.CreateInstance<GenericParameterHelper>(parameters);
            Assert.AreEqual(expected.Data, actual.Data);
        }

        /// <summary>
        ///A test for CreateInstance
        ///</summary>
        public void CreateInstanceDefaultConstructorTestHelper<T>()
            where T : new()
        {
            Type type = typeof(T); 
            T expected = new T(); 
            T actual;
            actual = type.CreateInstance<T>();
            Assert.IsNotNull(actual);
        }

        [TestMethod()]
        public void CreateInstanceDefaultConstructorTest()
        {
            CreateInstanceDefaultConstructorTestHelper<GenericParameterHelper>();
        }
    }
}
